<template>
  <div class="enterprises-institutions">
    <MapTitle text="“民参军”企事业单位研发投入情况" />
    <div class="meeting">
      <div>全省“民参军”企事业单位军品科研经费支出总额</div>
      <div class="frequency">
        {{ money || "--" }}
        <span class="second">亿元</span>
      </div>
    </div>
    <el-row class="investment">
      <el-col class="city-echarts">
        <div class="title2X">“民参军”企事业单位军品科研经费分布情况</div>
        <div id="enterprises" class="echart-item"></div>
      </el-col>
    </el-row>
  </div>
</template>
<script lang="ts">
import { defineComponent } from "vue";
import MapTitle from "@/components/mapTitle/index.vue";
import * as echarts from "echarts";
import { Aim } from "@element-plus/icons";
import Mock from "./mock";
import { mapState } from "vuex";

// 城市增长率
const xAxisCity = [
  "杭州",
  "宁波",
  "温州",
  "湖州",
  "嘉兴",
  "绍兴",
  "金华",
  "衢州",
  "舟山",
  "台州",
  "丽水",
];

let MAP_ECHARTS = null;

/**
 * 承担军需品情况
 */
export default defineComponent({
  components: {
    MapTitle,
    Aim,
  },
  setup() {},
  data() {
    return {
      countryEcharts: null,

      enterprises: null,
    };
  },
  mounted() {
    this.initEcharts();
  },
  watch: {
    seriesData() {
      MAP_ECHARTS.showLoading();
      MAP_ECHARTS.setOption(this.optionCity, true);
      MAP_ECHARTS.hideLoading();
    },
  },
  computed: {
    ...mapState({
      curDataType: (state) => state.curDataType,
    }),
    seriesData() {
      return Mock[this.curDataType].cityData;
    },
    money() {
      return Mock[this.curDataType].money;
    },
    optionCity() {
      const seriesBar = this.seriesData.map((item) => {
        return {
          type: "bar",

          itemStyle: {
            color: "#4198ff",
          },
          barWidth: 20,

          data: item.value.map((item) => {
            return {
              value: item,
              label: "收入规模",
            };
          }),
        };
      });

      return {
        tooltip: {
          trigger: "axis",
          axisPointer: {
            type: "shadow",
          },
          formatter: (params) => {
            let html = ``;

            html += `<div class="munition-echart ">
                <span class=" title color_1">${params[0].axisValue}市</span>
                <br />
                <span class="text text-color_1">${params[0].data.value}</span>亿元
               </div>
             `;

            return html;
          },
        },
        legend: {},
        grid: {
          top: "10%",
          left: "2%",
          right: "2%",
          bottom: "3%",
          containLabel: true,
        },
        yAxis: {
          type: "value",
          name: "金额(亿元)",
        },
        xAxis: {
          type: "category",
          data: xAxisCity,
        },
        series: [...seriesBar],
      };
    },
  },
  methods: {
    initEcharts() {
      this.initCityEcharts();
    },

    initCityEcharts() {
      const dom = document.getElementById("enterprises");
      MAP_ECHARTS = echarts.init(dom);
      MAP_ECHARTS.setOption(this.optionCity);

      this.enterprises = MAP_ECHARTS;
    },
  },
  unmounted() {
    if (this.enterprises) {
      this.enterprises.dispose();
      this.enterprises = null;
    }
  },
});
</script>

<style>
.munition-echart {
  width: 110px;
}
.munition-echart .name {
  margin-bottom: 15px;
  font-size: 14px;
  color: #333;
  font-weight: bold;
}
.munition-echart .title {
  padding-left: 10px;
  font-weight: 600;
  font-size: 12px;
  color: #666;
  position: relative;
}
.munition-echart .title::before {
  position: absolute;
  top: 5px;
  left: 0;
  content: " ";
  width: 6px;
  height: 6px;
  display: inline-block;
  border-radius: 50%;
}
.munition-echart .text {
  padding-left: 20px;
  margin-bottom: 20px;
}
.munition-echart .text:last-of-type {
  margin: 0;
}

.munition-echart .text-color_1 {
  color: #4198ff;
}
.munition-echart .text-color_2 {
  color: #eca933;
}
.munition-echart .color_1::before {
  background: #4198ff;
}
.munition-echart .color_2::before {
  background: #eca933;
}
/* 次数 */
.meeting {
  height: 50px;
  line-height: 50px;
  border-radius: 4px;
  color: #666666;
  background: rgba(248, 249, 251, 1);
  display: flex;
  justify-content: space-between;
  padding: 0 10px 0 10px;
  box-sizing: border-box;
  margin-top: 10px;
}
.frequency {
  color: rgba(65, 152, 255, 1);
  font-weight: 500;
  font-size: 20px;
  display: flex;
  align-items: center;
}
.second {
  margin-left: 5px;
  color: #666666;
  font-size: 12px;
  font-weight: normal;
}
</style>


<style lang="scss" scoped>
.enterprises-institutions {
  height: 100%;
  .investment {
    .echart-item {
      flex: 1;
      height: 300px;
      box-sizing: border-box;
      margin-top: 10px;
    }
    .card-list {
      // display: flex;
      // flex-direction: column;
      // padding: 20px 20px 20px 0;
      .card-item {
        flex: 1;
        box-sizing: border-box;
        margin-bottom: 15px;
        padding: 20px;
        background: #f8f9fb;
        display: flex;
        flex-direction: column;
        justify-content: center;
        border-radius: 5%;
        &:last-of-type {
          margin-bottom: 0;
        }
        p {
          font-size: 14px;
          color: #333;
          margin-bottom: 10px;
        }
        div {
          color: #4198ff;
          font-size: 20px;
        }
        .unit {
          color: #999;
          font-size: 12px;
        }
      }
    }

    .title2X {
      margin-top: 15px;
      font-size: 16px;
      color: #4198ff;
    }
  }
}
</style>
